var svg = d3.select('svg');
  
var margin = 80;
var width = 940 - 2 * margin;
var height = 480 - 2 * margin;

d3.csv("data.csv").then(function(data) {
  
// Creation du graphe + translation mathématique
  var chart = svg.append('g')
    .attr('transform', `translate(${margin}, ${margin})`);

// Axe des y  
  var yScale = d3.scaleLinear()
    .range([height, 0])
    .domain([650000, 800000
]);
  
  chart.append('g')
    .call(d3.axisLeft(yScale));
  
// Axe des ordonnées 
  var xScale = d3.scaleBand()
    .range([0, width])
    .domain(data.map((data) => data.기준년도_분기))
    .padding(0.2);

  chart.append('g')
      .attr('transform', `translate(0, ${height})`)
      .call(d3.axisBottom(xScale));

// Dessiner des gridlines
	chart.append('g')
      .attr('class', 'grid')
      .call(d3.axisLeft()
          .scale(yScale)
          .tickSize(-width, 0, 0)
          .tickFormat(''));
  
// Ajouter des titres au graphe
// Titre à gauche
  	svg.append('text')
      .attr('x', -(height / 2) - margin)
      .attr('y', margin / 5)
      .attr('transform', 'rotate(-90)')
      .attr('text-anchor', 'middle')
      .text('총 매출');
// Titre en haut
  	svg.append('text')
      .attr('class','title')
      .attr('x', width / 2 + margin)
      .attr('y', 40)
      .attr('text-anchor', 'middle')
      .text('강남구 년도별 분기별 매출');
// Titre en bas
  	svg.append('text')
      .attr('x', width / 2 + margin)
      .attr('y', height + 120)
      .attr('text-anchor', 'middle')
      .text('기준 년도_분기');
// Titre en haut
  	svg.append('text')
      .attr('x', width - 10)
      .attr('y', height + 150)
      .attr('text-anchor', 'start')
      .text('서울시 열린데이터 광장 기준');
      
// Lier les elements de l'array DOM element
  var barGroups = chart.selectAll()
  .data(data)
  .enter()
  .append('g');

  console.log(data);

// Dessiner des barres liées à chaque element des données
  barGroups
    .append('rect')
    .attr('class', 'bar')
    .attr('x', (data) => xScale(data.기준년도_분기))
    .attr('y', (data) => yScale(data.총유동인구수))
    .attr('height', (data) => height - yScale(data.총유동인구수))
    .attr('width', xScale.bandwidth());
  
  //Afficher la valeur sur chaque barre
  barGroups 
      .append('text')
      .attr('class', '총유동인구수')
      .attr('x', (data) => xScale(data.기준년도_분기) + xScale.bandwidth() / 2)
      .attr('y', (data) => yScale(data.총유동인구수) + 30)
      .attr('text-anchor', 'middle')
      .text((data) => `${data.총유동인구수}`)

// Event Listener: mouse enter
    barGroups.on('mouseenter', function (actual, i) {
      d3.selectAll('.총유동인구수')
            .attr('opacity', 0)
       
      d3.select(this)
        .transition()
        .duration(300)
        .attr('opacity', 0.6);

      var y = yScale(actual.총유동인구수);

      line = chart.append('line')
        .attr('id', 'limit')
        .attr('x1', 0)
        .attr('y1', y)
        .attr('x2', width)
        .attr('y2', y);

      barGroups.append('text')
        .attr('class', 'divergence')
        .attr('x', (data) => xScale(data.기준년도_분기) + xScale.bandwidth() / 2)
        .attr('y', (data) => yScale(data.총유동인구수) + 30)
        .attr('fill', 'white')
        .attr('text-anchor', 'middle')
        .text((data, idx) => {
          var divergence = (data.총유동인구수 - actual.총유동인구수).toFixed(1)

          let text = ''
          if (divergence > 0) text += '+'
          text += `${divergence}`

          return idx !== i ? text : ''; 
        })
    })

//Event Listener: mouse leave
    barGroups.on('mouseleave', function () {
      d3.selectAll('.총유동인구수')
        .attr('opacity', 1)

      d3.select(this)
        .trans